#include <graphics.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include "mys.h"

typedef float tip;

class vektor{
 public:
  tip x, y;
};

class bod {
 public:
  vektor poloha, rychlost;
  tip m;
};

class pole {
 public:
  bod *body;
  int pocet;
  tip norma, pruznost, treni;

  pole(int poc, tip m, tip n, tip p, tip t) {
    int i, j;
    pocet = poc;
    norma = n;
    pruznost = p;
    treni = t;
    body = new bod[pocet*pocet];
    for (i = 0; i < pocet; i ++) {
      for (j = 0; j < pocet; j ++) {
	body[i*pocet + j].poloha.x = 20 + i*n;
	body[i*pocet + j].poloha.y = 20 + j*n;
	body[i*pocet + j].rychlost.x = 0;
	body[i*pocet + j].rychlost.y = 0;
	body[i*pocet + j].m = m;
      }
    }
  }

  ~pole() {
    delete body;
  }

  void prepocti() {
    tip sila, vzd;
    int i, j;
    for (i = 0; i < pocet; i ++) {
      for (j = 1; j < pocet; j ++) {
	vzd = sqrt( pow(body[i*pocet + j-1].poloha.x - body[i*pocet + j].poloha.x, 2) + pow(body[i*pocet + j-1].poloha.y - body[i*pocet + j].poloha.y, 2) );
	sila = (1-norma/vzd)*(body[i*pocet + j-1].poloha.x - body[i*pocet + j].poloha.x)*pruznost + (body[i*pocet + j-1].rychlost.x - body[i*pocet + j].rychlost.x)*treni;
	body[i*pocet + j-1].rychlost.x -= sila/body[i*pocet + j-1].m;
	body[i*pocet + j].rychlost.x += sila/body[i*pocet + j].m;

	sila = (1-norma/vzd)*(body[i*pocet + j-1].poloha.y - body[i*pocet + j].poloha.y)*pruznost + (body[i*pocet + j-1].rychlost.y - body[i*pocet + j].rychlost.y)*treni;
	body[i*pocet + j-1].rychlost.y -= sila/body[i*pocet + j-1].m;
	body[i*pocet + j].rychlost.y += sila/body[i*pocet + j].m;
      }
    }

    for (i = 0; i < pocet; i ++) {
      for (j = 1; j < pocet; j ++) {
	vzd = sqrt( pow(body[i + (j-1)*pocet].poloha.x - body[i + j*pocet].poloha.x, 2) + pow(body[i + (j-1)*pocet].poloha.y - body[i + j*pocet].poloha.y, 2) );
	sila = (1-norma/vzd)*(body[i + (j-1)*pocet].poloha.x - body[i + j*pocet].poloha.x)*pruznost + (body[i + (j-1)*pocet].rychlost.x - body[i + j*pocet].rychlost.x)*treni;
	body[i + (j-1)*pocet].rychlost.x -= sila/body[i + (j-1)*pocet].m;
	body[i + j*pocet].rychlost.x += sila/body[i + j*pocet].m;

	sila = (1-norma/vzd)*(body[i + (j-1)*pocet].poloha.y - body[i + j*pocet].poloha.y)*pruznost + (body[i + (j-1)*pocet].rychlost.y - body[i + j*pocet].rychlost.y)*treni;
	body[i + (j-1)*pocet].rychlost.y -= sila/body[i + (j-1)*pocet].m;
	body[i + j*pocet].rychlost.y += sila/body[i + j*pocet].m;
      }
    }
  }

  void posun(void) {
    int i, j;
    for (i = 0; i < pocet; i ++) {
      for (j = 0; j < pocet; j ++) {
	body[i*pocet + j].poloha.x += body[i*pocet + j].rychlost.x;
	body[i*pocet + j].poloha.y += body[i*pocet + j].rychlost.y;
      }
    }
  }

  void kresli(void) {
    int i, j;
    for (i = 0; i < pocet; i ++) {
      for (j = 0; j < pocet; j ++) {
	putpixel(body[i*pocet + j].poloha.x, body[i*pocet + j].poloha.y, 15);
      }
    }
  }

  void stop(int kx, int ky, int x, int y) {
    if ((kx < 0)||(kx > pocet)) kx = pocet - 1;
    if ((ky < 0)||(ky > pocet)) ky = pocet - 1;
    body[kx*pocet + ky].poloha.x = x;
    body[kx*pocet + ky].poloha.y = y;
    body[kx*pocet + ky].rychlost.x = 0;
    body[kx*pocet + ky].rychlost.y = 0;
  }

};

void main() {
  int gm, gd, swp = 0;
  gd = 9;
  gm = 1;
  initgraph(&gd, &gm, "");

  mouse mys;
  mys.set_off();
  mys.set_xy(20,20);
  pole plocha(30, 10, 2, 4, 3);
  while (!kbhit()) {
    mys.aktual();
    plocha.stop(0, 0, mys.get_x(), mys.get_y());
    plocha.stop(-1, -1, 300, 100);
    plocha.stop(0, -1, 100, 100);
    plocha.prepocti();
    plocha.posun();
//    plocha.gravitace(0.1);
    setactivepage(swp);
    cleardevice();
    plocha.kresli();
    setvisualpage(swp);
    swp?swp --:swp ++;
//    delay(10);
  }

  getch();
  closegraph();
}