#include <graphics.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>
#include <dos.h>
#include "mys.h"

typedef float tip;

class vektor {
 public:
  tip x, y;
};

class clanek {
 public:
  int m;
  vektor poloha;
  vektor rychlost;
};

class retizek {
 public:
  clanek *clanky;
  int pocet;
  tip pruznost, norma, treni;

  retizek(int poc, int m, tip n,tip p, tip t) {
    if (poc > 1) pocet = poc;
    else pocet = 2;
    pruznost = p;
    norma = n;
    treni = t;
    clanky = new clanek[pocet];
    int i;
    for (i = 0; i < pocet; i ++) {
      clanky[i].m = m;
      clanky[i].poloha.x = 20 + i*10;
      clanky[i].poloha.y = 20;
      clanky[i].rychlost.x = 0;
      clanky[i].rychlost.y = 0;
    }
  }

  ~retizek() {
    delete clanky;
  }

  void prepocti(void) {
    int i;
    tip sila, vzd;
    for (i = 1; i < pocet; i ++) {
      vzd = sqrt( pow(clanky[i-1].poloha.x - clanky[i].poloha.x, 2) + pow(clanky[i-1].poloha.y - clanky[i].poloha.y, 2) );
      sila = (1-norma/vzd)*(clanky[i-1].poloha.x - clanky[i].poloha.x)*pruznost + (clanky[i-1].rychlost.x - clanky[i].rychlost.x)*treni;
      clanky[i-1].rychlost.x -= sila/clanky[i-1].m;
      clanky[i].rychlost.x += sila/clanky[i].m;

      sila = (1-norma/vzd)*(clanky[i-1].poloha.y - clanky[i].poloha.y)*pruznost + (clanky[i-1].rychlost.y - clanky[i].rychlost.y)*treni;
      clanky[i-1].rychlost.y -= sila/clanky[i-1].m;
      clanky[i].rychlost.y += sila/clanky[i].m;
    }
  }

  void posun(void) {
    int i;
    for (i = 0; i < pocet; i ++) {
      clanky[i].poloha.x += clanky[i].rychlost.x;
      clanky[i].poloha.y += clanky[i].rychlost.y;
    }
  }

  void gravitace(tip g) {
    int i;
    for (i = 0; i < pocet; i ++) {
      clanky[i].rychlost.y += g;
    }
  }

  void stop(int ktery, int x, int y) {
    if ((ktery < 0)||(ktery >= pocet)) ktery = pocet -1;
    clanky[ktery].poloha.x = x;
    clanky[ktery].poloha.y = y;
    clanky[ktery].rychlost.x = 0;
    clanky[ktery].rychlost.y = 0;
  }

  void kresli(void) {
    int i = 0;
    moveto(clanky[i].poloha.x, clanky[i].poloha.y);
    for (i = 1; i < pocet; i ++) {
      if ((i % 2) == 0) setcolor(12);
      else setcolor(15);
      lineto(clanky[i].poloha.x, clanky[i].poloha.y);
//      putpixel(clanky[i].poloha.x, clanky[i].poloha.y, 15);
    }
  }

};

void main() {
  int gm, gd, swp = 0;
  gd = 9;
  gm = 1;
  initgraph(&gd, &gm, "");

  mouse mys;
  mys.set_off();
  mys.set_xy(20,20);
  retizek guma(30, 10, 5, 5, 4);

  while (!kbhit()) {
    mys.aktual();
    guma.stop(0, mys.get_x(), mys.get_y());
    guma.stop(-1, 300, 100);
    guma.prepocti();
    guma.posun();
    guma.gravitace(0.1);
    setactivepage(swp);
    cleardevice();
    guma.kresli();
    setvisualpage(swp);
    swp?swp --:swp ++;
    delay(10);
  }

  getch();
  closegraph();
}